<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetResourcePriorityNamespaceReq StructType
 * @subpackage Structs
 */
class GetResourcePriorityNamespaceReq extends AbstractStructBase
{
    /**
     * The namespace
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * - maxLength: 10
     * @var string
     */
    public $namespace;
    /**
     * The uuid
     * Meta informations extracted from the WSDL
     * - pattern: \{........-....-....-....-............\}
     * @var string
     */
    public $uuid;
    /**
     * The returnedTags
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var RResourcePriorityNamespace
     */
    public $returnedTags;
    /**
     * The sequence
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for GetResourcePriorityNamespaceReq
     * @uses GetResourcePriorityNamespaceReq::setNamespace()
     * @uses GetResourcePriorityNamespaceReq::setUuid()
     * @uses GetResourcePriorityNamespaceReq::setReturnedTags()
     * @uses GetResourcePriorityNamespaceReq::setSequence()
     * @param string $namespace
     * @param string $uuid
     * @param RResourcePriorityNamespace $returnedTags
     * @param int $sequence
     */
    public function __construct($namespace = null, $uuid = null, RResourcePriorityNamespace $returnedTags = null, $sequence = null)
    {
        $this
            ->setNamespace($namespace)
            ->setUuid($uuid)
            ->setReturnedTags($returnedTags)
            ->setSequence($sequence);
    }
    /**
     * Get namespace value
     * @return string
     */
    public function getNamespace()
    {
        return $this->namespace;
    }
    /**
     * Set namespace value
     * @param string $namespace
     * @return GetResourcePriorityNamespaceReq
     */
    public function setNamespace($namespace = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($namespace) && strlen($namespace) > 10) || (is_array($namespace) && count($namespace) > 10)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 10 element(s) or a scalar of 10 character(s) at most, "%d" length given', is_scalar($namespace) ? strlen($namespace) : count($namespace)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($namespace) && !is_string($namespace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($namespace)), __LINE__);
        }
        $this->namespace = $namespace;
        return $this;
    }
    /**
     * Get uuid value
     * @return string|null
     */
    public function getUuid()
    {
        return $this->uuid;
    }
    /**
     * Set uuid value
     * @param string $uuid
     * @return GetResourcePriorityNamespaceReq
     */
    public function setUuid($uuid = null)
    {
        // validation for constraint: pattern
        if (is_scalar($uuid) && !preg_match('/\{........-....-....-....-............\}/', $uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a scalar value that matches "\{........-....-....-....-............\}", "%s" given', var_export($uuid, true)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($uuid) && !is_string($uuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uuid)), __LINE__);
        }
        $this->uuid = $uuid;
        return $this;
    }
    /**
     * Get returnedTags value
     * @return RResourcePriorityNamespace|null
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param RResourcePriorityNamespace $returnedTags
     * @return GetResourcePriorityNamespaceReq
     */
    public function setReturnedTags(RResourcePriorityNamespace $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return GetResourcePriorityNamespaceReq
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: int
        if (!is_null($sequence) && !is_numeric($sequence)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return GetResourcePriorityNamespaceReq
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
